/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the RevokeUserPermissionsRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &RevokeUserPermissionsRequest{}

// RevokeUserPermissionsRequest struct for RevokeUserPermissionsRequest
type RevokeUserPermissionsRequest struct {
	Target *string `json:"target,omitempty"`
	Channels []string `json:"channels,omitempty"`
}

// NewRevokeUserPermissionsRequest instantiates a new RevokeUserPermissionsRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewRevokeUserPermissionsRequest() *RevokeUserPermissionsRequest {
	this := RevokeUserPermissionsRequest{}
	return &this
}

// NewRevokeUserPermissionsRequestWithDefaults instantiates a new RevokeUserPermissionsRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRevokeUserPermissionsRequestWithDefaults() *RevokeUserPermissionsRequest {
	this := RevokeUserPermissionsRequest{}
	return &this
}

// GetTarget returns the Target field value if set, zero value otherwise.
func (o *RevokeUserPermissionsRequest) GetTarget() string {
	if o == nil || IsNil(o.Target) {
		var ret string
		return ret
	}
	return *o.Target
}

// GetTargetOk returns a tuple with the Target field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RevokeUserPermissionsRequest) GetTargetOk() (*string, bool) {
	if o == nil || IsNil(o.Target) {
		return nil, false
	}
	return o.Target, true
}

// HasTarget returns a boolean if a field has been set.
func (o *RevokeUserPermissionsRequest) HasTarget() bool {
	if o != nil && !IsNil(o.Target) {
		return true
	}

	return false
}

// SetTarget gets a reference to the given string and assigns it to the Target field.
func (o *RevokeUserPermissionsRequest) SetTarget(v string) {
	o.Target = &v
}

// GetChannels returns the Channels field value if set, zero value otherwise.
func (o *RevokeUserPermissionsRequest) GetChannels() []string {
	if o == nil || IsNil(o.Channels) {
		var ret []string
		return ret
	}
	return o.Channels
}

// GetChannelsOk returns a tuple with the Channels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RevokeUserPermissionsRequest) GetChannelsOk() ([]string, bool) {
	if o == nil || IsNil(o.Channels) {
		return nil, false
	}
	return o.Channels, true
}

// HasChannels returns a boolean if a field has been set.
func (o *RevokeUserPermissionsRequest) HasChannels() bool {
	if o != nil && !IsNil(o.Channels) {
		return true
	}

	return false
}

// SetChannels gets a reference to the given []string and assigns it to the Channels field.
func (o *RevokeUserPermissionsRequest) SetChannels(v []string) {
	o.Channels = v
}

func (o RevokeUserPermissionsRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o RevokeUserPermissionsRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Target) {
		toSerialize["target"] = o.Target
	}
	if !IsNil(o.Channels) {
		toSerialize["channels"] = o.Channels
	}
	return toSerialize, nil
}

type NullableRevokeUserPermissionsRequest struct {
	value *RevokeUserPermissionsRequest
	isSet bool
}

func (v NullableRevokeUserPermissionsRequest) Get() *RevokeUserPermissionsRequest {
	return v.value
}

func (v *NullableRevokeUserPermissionsRequest) Set(val *RevokeUserPermissionsRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableRevokeUserPermissionsRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableRevokeUserPermissionsRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableRevokeUserPermissionsRequest(val *RevokeUserPermissionsRequest) *NullableRevokeUserPermissionsRequest {
	return &NullableRevokeUserPermissionsRequest{value: val, isSet: true}
}

func (v NullableRevokeUserPermissionsRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableRevokeUserPermissionsRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


